<?php
if ( ! defined( 'WPINC' ) ) {
	die;
}

function dws_worker_filter_post_class( $classes ) {
	global $post;
    $my_post_class = get_post_meta($post->ID, "dws_post_class",true);

    if( $my_post_class != '' )
      $classes[] = $my_post_class;

    return $classes;
}
add_filter( 'post_class', 'dws_worker_filter_post_class' );
add_filter( 'body_class', 'dws_worker_filter_post_class' );

function dws_worker_gallery_defaults( $settings ) {

    $settings['galleryDefaults']['columns'] = 5;
	$settings['galleryDefaults']['link'] = 'file';
    return $settings;
}
add_filter( 'media_view_settings', 'dws_worker_gallery_defaults' );

function dws_worker_remove_page_attribute_meta_box()
{
    if( is_admin() ) {
        if (!current_user_can('administrator')) {
			remove_meta_box('postcustom', 'page', 'normal');
			remove_meta_box('postcustom', 'post', 'normal');
        }
    }
}
add_action( 'admin_menu', 'dws_worker_remove_page_attribute_meta_box', 999 );

function dws_admin_bar($admin_bar){

    $admin_bar->remove_menu( 'wp-logo' );
    $admin_bar->remove_menu( 'about' );
    $admin_bar->remove_menu( 'wporg' );
    $admin_bar->remove_menu( 'documentation' );
    $admin_bar->remove_menu( 'support-forums' );
    $admin_bar->remove_menu( 'feedback' );

	if (!current_user_can('administrator')) {
		$admin_bar->remove_menu( 'updates' );
		$admin_bar->remove_menu( 'comments' );
		$admin_bar->remove_menu( 'new-content' );
		$admin_bar->remove_menu( 'my-sites' );
	}
}
add_action( 'admin_bar_menu', 'dws_admin_bar', 999);


function dws_worker_remove_menus() {

	if(!current_user_can('update_core')){
		remove_submenu_page('woocommerce', 'wc-status');
		remove_submenu_page('woocommerce', 'wc-addons');
		remove_submenu_page('woocommerce', 'wpo_wcpdf_options_page');
		remove_submenu_page('elementor', 'elementor-system-info');
		remove_submenu_page('elementor', 'elementor-getting-started');
		remove_submenu_page('elementor', 'elementor-license');
		remove_submenu_page('elementor', 'go_knowledge_base_site');
		remove_submenu_page('wpseo_dashboard', 'wpseo_licenses');
		remove_submenu_page('wpseo_dashboard', 'wpseo_courses');
	}
}
add_action( 'admin_menu','dws_worker_remove_menus', 99999);

function dws_worker_remove_metabox(){

	if (!current_user_can('administrator')) {
		remove_meta_box('dashboard_right_now', 'dashboard', 'core');
		remove_meta_box('dashboard_welcome_panel', 'dashboard', 'core');
		remove_meta_box('dashboard_activity', 'dashboard', 'core');
		remove_meta_box('dashboard_recent_comments', 'dashboard', 'core');
		remove_meta_box('dashboard_incoming_links', 'dashboard', 'core');
		remove_meta_box('dashboard_plugins', 'dashboard', 'core');
		remove_meta_box('dashboard_quick_press', 'dashboard', 'core');
		remove_meta_box('dashboard_recent_drafts', 'dashboard', 'core');
		remove_meta_box('dashboard_primary', 'dashboard', 'core');
		remove_meta_box('dashboard_secondary', 'dashboard', 'core');
		remove_meta_box('so-dashboard-news', 'dashboard', 'core');
		remove_meta_box('themeisle', 'dashboard', 'core');
		//remove_meta_box('e-dashboard-overview', 'dashboard', 'core');
		remove_meta_box('owp_dashboard_news', 'dashboard', 'core');
		remove_meta_box('wpseo-dashboard-overview', 'dashboard', 'core');
	}
	remove_action('welcome_panel', 'wp_welcome_panel');
}
add_action( 'admin_init', 'dws_worker_remove_metabox');

add_filter( 'update_footer', function () {
	return '';
}, 999);

add_filter( 'admin_footer_text', function () {
  	return '<a href="https://digitalwordings.com/">Digital Wordings</a>';
}, 999);

function dws_worker_remove_help_tab() {
	if( is_user_logged_in() ) {
		if (!current_user_can('administrator')) {
			$screen = get_current_screen();
			$screen->remove_help_tabs();
			$screen->remove_help_tab( 'overview' );
			$screen->remove_help_tab( 'help-navigation' );
			$screen->remove_help_tab( 'help-layout' );
			$screen->remove_help_tab( 'help-content' );
			$screen->remove_help_tab( 'attachment-details' );
			$screen->remove_help_tab( 'managing-pages' );
			$screen->remove_help_tab( 'managing-pages' );
			$screen->remove_help_tab( 'moderating-comments' );
			$screen->remove_help_tab( 'adding-themes' );
			$screen->remove_help_tab( 'customize-preview-themes' );
			$screen->remove_help_tab( 'compatibility-problems' );
			$screen->remove_help_tab( 'adding-plugins' );
			$screen->remove_help_tab( 'screen-display' );
			$screen->remove_help_tab( 'actions' );
			$screen->remove_help_tab( 'user-roles' );
			$screen->remove_help_tab( 'press-this' );
			$screen->remove_help_tab( 'converter' );
			$screen->remove_help_tab( 'options-postemail' );
			$screen->remove_help_tab( 'options-services' );
			$screen->remove_help_tab( 'site-visibility' );
			$screen->remove_help_tab( 'permalink-settings' );
			$screen->remove_help_tab( 'custom-structures' );
		}
	}
}
	
add_action( 'current_screen', 'dws_worker_remove_help_tab');

function dws_worker_custom_login_logo() {
   $options = get_option( 'dws_settings' ); 
	echo '<style type="text/css">
	.login h1 a {
		background-image: url(' . $options['dws_login_logo'] . ') !important; 
			height:72px;
			width:220px;
			background-size: 220px 72px;
			background-repeat: no-repeat;
			padding-bottom: 30px;
		}
	</style>';
}
add_action('login_head', 'dws_worker_custom_login_logo');

function dws_worker_login_logo_url() {
    return home_url();
}
add_filter( 'login_headerurl', 'dws_worker_login_logo_url' );
 
function dws_worker_login_logo_url_title() {
    return 'Welcome';
}
add_filter( 'login_headertitle', 'dws_worker_login_logo_url_title' );

add_action('admin_head', 'my_custom_fonts');

function my_custom_fonts() {
?>
<style>
    .e-notice.notice, #pp_custom_css_js_dev_info {
    display: none;
    } 
  </style>
<?php
}