<?php

if ( ! defined( 'WPINC' ) ) {
	die;
}

add_action( 'admin_menu', 'dws_worker_add_admin_menu' );
add_action( 'admin_init', 'dws_worker_settings_init' );

function dws_worker_add_admin_menu(  ) { 
	add_menu_page( 'Digital Wordings Worker Options', 'Digital Wordings Worker Options', 'manage_options', 'digital_wordings_worker_options', 'dws_worker_options_page' );
}

function dws_worker_settings_init(  ) {
	register_setting( 'dws_options', 'dws_settings' );
}


function dws_worker_options_page() {
	?>
	<table class="widefat">
		<form action='options.php' method='post'>
			<h2>Digital Wordings Site Options</h2>
			<?php
			settings_fields( 'dws_options' );
			do_settings_sections( 'dws_options' );
			$options = get_option( 'dws_settings' );  ?>
			<tr><td><label for="dws-login-logo"> Login Logo </label></td>
			<td><input type='text' name='dws_settings[dws_login_logo]' id="dws-login-logo" value='<?php echo isset($options['dws_login_logo']) ? $options['dws_login_logo'] : ''; ?>'></td></tr>
			
			<tr><td><label for="dws-disable-email"> Disable SMTP Mail </label></td>
			<td><input type='checkbox' name='dws_settings[dws_disable_email]' id="dws-disable-email" value='true' <?php echo isset($options['dws_disable_email']) ? ( ( $options['dws_disable_email'] == 'true' ) ? 'checked' : '' ) : ''; ?>>Check to Disable Mail</td></tr>
			
			<tr><td><label for="dws-custom-smtp"> Enable custom SMTP </label></td>
			<td><input type='checkbox' name='dws_settings[dws_custom_smtp]' id="dws-custom-smtp" value='true' <?php echo isset($options['dws_custom_smtp']) ? ( ( $options['dws_custom_smtp'] == 'true' ) ? 'checked' : '' ) : ''; ?>>Check to Enable your custom SMTP(It will override the default smtp credentials)</td></tr>
			
			<tr><td><label for="dws_smtp_host"> SMTP HOST </label></td>
			<td><input type='text' name='dws_settings[dws_smtp_host]' id="dws_smtp_host" value='<?php echo isset($options['dws_smtp_host']) ? $options['dws_smtp_host'] : ''; ?>'></td></tr>
			
			<tr><td><label for="dws_smtp_user"> SMTP User </label></td>
			<td><input type='text' name='dws_settings[dws_smtp_user]' id="dws_smtp_user" value='<?php echo isset($options['dws_smtp_user']) ? $options['dws_smtp_user'] : ''; ?>'></td></tr>
			
			<tr><td><label for="dws_smtp_password"> SMTP Password </label></td>
			<td><input type='text' name='dws_settings[dws_smtp_password]' id="dws_smtp_password" value='<?php echo isset($options['dws_smtp_password']) ? $options['dws_smtp_password'] : ''; ?>'></td></tr>
			
			<tr><td><label for="dws_smtp_from"> SMTP From(Email) </label></td>
			<td><input type='text' name='dws_settings[dws_smtp_from]' id="dws_smtp_from" value='<?php echo isset($options['dws_smtp_from']) ? $options['dws_smtp_from'] : ''; ?>'>Enter the source Email</td></tr>
			
			<tr><td><label for="dws_smtp_name"> SMTP Name </label></td>
			<td><input type='text' name='dws_settings[dws_smtp_name]' id="dws_smtp_name" value='<?php echo isset($options['dws_smtp_name']) ? $options['dws_smtp_name'] : ''; ?>'></td></tr>
			
			<tr><td><label for="dws_smtp_port"> SMTP PORT </label></td>
			<td><input type='text' name='dws_settings[dws_smtp_port]' id="dws_smtp_port" value='<?php echo isset($options['dws_smtp_port']) ? $options['dws_smtp_port'] : 465; ?>'>SMTP port number - likely to be 25, 465 or 587</td></tr>
			
			<tr><td><label for="dws_smtp_secure"> SMTP Secure </label></td>
			<td><input type='text' name='dws_settings[dws_smtp_secure]' id="dws_smtp_secure" value='<?php echo isset($options['dws_smtp_secure']) ? $options['dws_smtp_secure'] : 'ssl'; ?>'>Encryption system to use - ssl or tls</td></tr>
			
			<tr><td><label for="dws_smtp_auth"> SMTP Auth </label></td>
			<td><input type='text' name='dws_settings[dws_smtp_auth]' id="dws_smtp_auth" value='<?php echo isset($options['dws_smtp_auth']) ? $options['dws_smtp_auth'] : true; ?>'>Use SMTP authentication (true(1)|false(0))</td></tr>
			
			<tr><td><?php submit_button(); ?></td></tr>
			
		</form>
	</table>

	<?php
	$option_name = 'wposso_options';
    $options = get_option( $option_name );
    admin_head();
    ?>
    <div class="wrap">
        <h2>Digital Wordings login Configuration</h2>
        <p>
            When activated, this plugin adds a Digital Wordings login button to the login screen.
            <br/>
            <strong>NOTE:</strong> If you want to add a
            custom link anywhere in your theme simply link to
            <strong><?php echo site_url( '?auth=sso' ); ?></strong>
            if the user is not logged in.
        </p>
        <div id="accordion">
            <h4>Step 1: Setup</h4>
            <div>
                <strong>Setting up WordPress OAuth Server</strong>
                <ol>
                    <li>Enable Authorization Code</li>
                    <li>Create a new client and set the Redirect URI to:
                        <strong class="code"><?php echo site_url( '?auth=sso' ); ?></strong></li>
                    <li>Copy the Client ID and Client Secret in Step 2 below.</li>
                </ol>
            </div>
            <h4 id="ssso-configuration">Step 2: Configuration</h4>
            <div>
                <form method="post" action="options.php">
                    <?php settings_fields( 'wposso_options' ); ?>
                    <table class="form-table">
                        <tr valign="top">
                            <th scope="row">Client ID</th>
                            <td>
                                <input type="text" name="<?php echo $option_name ?>[client_id]" min="10"
                                       value="<?php echo $options["client_id"]; ?>"/>
                            </td>
                        </tr>

                        <tr valign="top">
                            <th scope="row">Client Secret</th>
                            <td>
                                <input type="text" name="<?php echo $option_name ?>[client_secret]" min="10"
                                       value="<?php echo $options["client_secret"]; ?>"/>
                            </td>
                        </tr>

                        <tr valign="top">
                            <th scope="row">OAuth Server URL</th>
                            <td>
                                <input type="text" name="<?php echo $option_name ?>[server_url]" min="10"
                                       value="<?php echo $options["server_url"]; ?>"/>
                                <p class="description">Example: https://your-site.com</p>
                            </td>
                        </tr>

                        <tr valign="top">
                            <th scope="row">Redirect to the dashboard after signing in</th>
                            <td>
                                <input type="checkbox"
                                       name="<?php echo $option_name ?>[redirect_to_dashboard]"
                                       value="1" <?php echo @$options['redirect_to_dashboard'] == 1 ? 'checked="checked"' : ''; ?> />
                            </td>
                        </tr>
                        <tr valign="top">
                            <th scope="row">Restrict flow to log in only</th>
                            <td>
                                <input type="checkbox"
                                       name="<?php echo $option_name ?>[login_only]"
                                       value="1" <?php echo @$options['login_only'] == 1 ? 'checked="checked"' : ''; ?> />
                            </td>
                        </tr>
                    </table>

                    <p class="submit">
                        <input type="submit" class="button-primary" value="<?php _e( 'Save Changes' ) ?>"/>
                    </p>
            </div>

            </form>
        </div>
    </div>
    <div style="clear:both;"></div>
    </div>
	<?php
}