<?php
require_once dirname( __FILE__ ) . '/plugin-update-checker/plugin-update-checker.php';

$update_plugin_slug = array('woo-tour', 'theplus_elementor_addon', 'digital-wordings-worker', 'elementor-pro', 'jet-blocks', 'jet-blog', 'jet-compare-wishlist', 'jet-data-importer', 'jet-elements', 'jet-elements-dynamic-data', 'jet-engine', 'jet-menu', 'jet-plugins-wizard', 'jet-popup', 'jet-reviews', 'jet-search','jet-compare-wishlist', 'jet-smart-filters', 'jet-tabs', 'jet-theme-core', 'jet-theme-wizard', 'jet-tricks', 'jet-woo-builder', 'jet-woo-product-gallery', 'LayerSlider', 'revslider', 'woocommerce-product-table', 'product-addons');

if( !empty( get_option('wposso_options') ) ) {
	$queryArgs1['license_key'] = get_option('wposso_options')['client_id'];
	$queryArgs1['client_secret'] = get_option('wposso_options')['client_secret'];
	$queryArgs1['server_url'] = get_option('wposso_options')['server_url'];
	$queryArgs1['redirect_url'] = site_url( '?auth=sso' );
}

foreach( $update_plugin_slug as $slug ){

	if( file_exists( WP_PLUGIN_DIR . '/'.$slug.'/'.$slug.'.php' ) ) {
		$updaters[ $slug ] = Puc_v4_Factory::buildUpdateChecker(
			DWS_SERVER_URL.'?action=get_metadata&query_arg='.json_encode($queryArgs1).'&slug='.$slug,
			WP_PLUGIN_DIR . '/'.$slug.'/'.$slug.'.php',
			$slug
		);
		// $updaters[ $slug ]->addQueryArgFilter('wsh_filter_update_checks_dws_'.str_replace('-','_',$slug));
	}
}

function wsh_filter_update_checks_dws_theplus_elementor_addon( $queryArgs ){
	redirect_arg( $queryArgs );
}
function wsh_filter_update_checks_dws_digital_wordings_worker( $queryArgs ){
	redirect_arg( $queryArgs );
}
function wsh_filter_update_checks_dws_elementor_pro( $queryArgs ){
	redirect_arg( $queryArgs );
}
function wsh_filter_update_checks_dws_jet_blocks( $queryArgs ){
	redirect_arg( $queryArgs );
}
function wsh_filter_update_checks_dws_jet_blog( $queryArgs ){
	redirect_arg( $queryArgs );
}
function wsh_filter_update_checks_dws_jet_compare_wishlist( $queryArgs ){
	redirect_arg( $queryArgs );
}
function wsh_filter_update_checks_dws_jet_data_importer( $queryArgs ){
	redirect_arg( $queryArgs );
}
function wsh_filter_update_checks_dws_jet_elements( $queryArgs ){
	redirect_arg( $queryArgs );
}
function wsh_filter_update_checks_dws_jet_elements_dynamic_data( $queryArgs ){
	redirect_arg( $queryArgs );
}
function wsh_filter_update_checks_dws_jet_engine( $queryArgs ){
	redirect_arg( $queryArgs );
}
function wsh_filter_update_checks_dws_jet_menu( $queryArgs ){
	redirect_arg( $queryArgs );
}
function wsh_filter_update_checks_dws_jet_plugins_wizard( $queryArgs ){
	redirect_arg( $queryArgs );
}
function wsh_filter_update_checks_dws_jet_popup( $queryArgs ){
	redirect_arg( $queryArgs );
}
function wsh_filter_update_checks_dws_jet_reviews( $queryArgs ){
	redirect_arg( $queryArgs );
}
function wsh_filter_update_checks_dws_jet_search( $queryArgs ){
	redirect_arg( $queryArgs );
}
function wsh_filter_update_checks_dws_jet_smart_filters( $queryArgs ){
	redirect_arg( $queryArgs );
}
function wsh_filter_update_checks_dws_jet_tabs($queryArgs){
	redirect_arg($queryArgs);
}
function wsh_filter_update_checks_dws_jet_theme_core($queryArgs){
	redirect_arg($queryArgs);
}
function wsh_filter_update_checks_dws_jet_theme_wizard($queryArgs){
	redirect_arg($queryArgs);
}
function wsh_filter_update_checks_dws_jet_tricks($queryArgs){
	redirect_arg($queryArgs);
}
function wsh_filter_update_checks_dws_jet_woo_builder($queryArgs){
	redirect_arg($queryArgs);
}
function wsh_filter_update_checks_dws_jet_woo_product_gallery($queryArgs){
	redirect_arg($queryArgs);
}
function wsh_filter_update_checks_dws_LayerSlider($queryArgs){
	redirect_arg($queryArgs);
}
function wsh_filter_update_checks_dws_revslider($queryArgs){
	redirect_arg($queryArgs);
}

function redirect_arg($queryArgs) {
	if( !empty( get_option('wposso_options') ) ) {
		$queryArgs['license_key'] = get_option('wposso_options')['client_id'];
		$queryArgs['client_secret'] = get_option('wposso_options')['client_secret'];
		$queryArgs['server_url'] = get_option('wposso_options')['server_url'];
	} else {
		$queryArgs['empty'] = 'empty';
	}
	return $queryArgs;
}


$theme = wp_get_theme(); // gets the current theme
	if ( 'Woodmart' == $theme->name || 'Woodmart' == $theme->parent_theme ) {
	$myUpdateChecker = Puc_v4_Factory::buildUpdateChecker(
		DWS_SERVER_URL.'?action=get_metadata&query_arg='.json_encode($queryArgs1).'&slug=woodmart-theme',
		get_theme_root() . '/woodmart/functions.php', //Full path to the main plugin file or functions.php.
		'woodmart-theme'
	);
	$myUpdateChecker->addQueryArgFilter('wsh_filter_update_checks_woodmart');
	function wsh_filter_update_checks_woodmart($queryArgs) {
		if( !empty( get_option('wposso_options') ) ) {
			$queryArgs['license_key'] = get_option('wposso_options')['client_id'];
			$queryArgs['client_secret'] = get_option('wposso_options')['client_secret'];
			$queryArgs['server_url'] = get_option('wposso_options')['server_url'];
			return $queryArgs;
		}
	}
}


// Code goes for Themes Updates

require_once dirname( __FILE__ ) . '/theme-updates/theme-update-checker.php';
$example_update_checker = new ThemeUpdateChecker(
    'custom',
	DWS_SERVER_URL.'?action=get_metadata&query_arg='.json_encode($queryArgs1).'&slug=custom'
);